﻿using System.Linq;
using System;

public class Program
{
    public static void Main(string[] args)
    {
        //Код программы соответсвует четвертому варианту, поскольку во втором задании требуется наименьшее четное, которое требуется только в этом варианте.

        Console.WriteLine("Введите номер задачи: ");
        int num = Convert.ToInt32(Console.ReadLine());
        switch (num)
        { 
            case 1: getOneTask(); Console.ReadKey(); break;
            //Первое задание без ошибок, однако при генерации может не сгенерироваться либо односимвольное, либо двусимвольное число, в результате чего изменения не будут произведены. 
            //Добавлены флаги для отслеживания, препятствующие выводу неизмененного массива
            case 2: getTwoTask(); Console.ReadKey(); break;
            //Во втором задании не выводится код символа. Проблема была в том, что мин. значение было задано некорректно (0), из-за чего каждое сравниваемое значение было заведомо больше
            //Также были добавлены флаги, отслеживающие наличие необходимого элемента в сгенерированном массиве. Если этого не произошло -- выводится соответствующее сообщение.
            case 3: getThreeTask(); Console.ReadKey(); break;
            //Третье задание без ошибок
            case 4: getFourTask(); Console.ReadKey(); break;
            //Четвертое задание без ошибок
            case 5: getFiveTask(); Console.ReadKey(); break;
            //Пятое задание работало без ошибок, за исключением неумения "прочитать" отсутствие прописных букв в пароле. Исправлено введением доп условия.
        }
    }
    static void getOneTask()
    {
        Console.Write("Введите размерность массива: ");
        bool shortIsFound = false;
        bool longIsFound = false; 
        int n = Convert.ToInt32(Console.ReadLine());
        int[] arr = new int[n];
        Random rnd = new Random();
        for (int i = 0; i < arr.Length; i++)
        {
            arr[i] = rnd.Next(1, 100);
        }
        Console.WriteLine("Исходный массив: ");
        foreach (int item in arr)
        {
            Console.Write($"{item} ");
        }
        int od = arr[0], dv = arr[0], odInd = 0, dvInd = 0;
        for (int i = 0; i < arr.Length; i++)
        {
            if (1 == Convert.ToString(arr[i]).Length)
            {
                od = arr[i];
                odInd = i;
                shortIsFound = true;
                break;
            }
        }
        for (int i = 0; i < arr.Length; i++)
        {
            if (2 == Convert.ToString(arr[i]).Length)
            {
                dv = arr[i];
                dvInd = i;
                longIsFound = true;
                break;
            }
        }
        int x;
        x = arr[odInd];
        arr[odInd] = arr[dvInd];
        arr[dvInd] = x;
        if (shortIsFound && longIsFound)
        {
            Console.WriteLine("\nИзмененный массив: ");
            foreach (int item in arr)
            {
                Console.Write($"{item} ");
            }
        }
        else
            Console.WriteLine("Не удалось совершить изменения");
    }

    static void getTwoTask()
    {
        Console.Write("Введите размерность по строкам: ");
        int m = Convert.ToInt32(Console.ReadLine());
        Console.Write("Введите размерность по столбцам: ");
        int n = Convert.ToInt32(Console.ReadLine());
        char[,] arr = new char[n, m];
        Random rnd = new Random();
        for (int i = 0; i < arr.GetLength(0); i++)
        {
            for (int j = 0; j < arr.GetLength(1); j++)
            {
                arr[i, j] = (char)rnd.Next('A', 'Z');
            }
        }
        Console.WriteLine("Итоговая матрица: ");
        for (int i = 0; i < arr.GetLength(0); i++)
        {
            for (int j = 0; j < arr.GetLength(1); j++)
            {
                Console.Write($"{arr[i, j]} ");
            }
            Console.WriteLine();
        }
        showMaxEvenCharID(arr);
    }

    static void showMaxEvenCharID(char[,] arr)
    {
        int min = int.MaxValue;
        char ch = arr[0, 0];
        bool isFound = false;
        for (int i = 0; i < arr.GetLength(0); i++)
        {
            for (int j = 0; j < arr.GetLength(1); j++)
            {
                if (min > Convert.ToInt32(arr[i, j]) && Convert.ToInt32(arr[i, j]) % 2 == 0)
                {
                    min = Convert.ToInt32(arr[i, j]);
                    ch = arr[i, j];
                    isFound = true;
                }
            }
        }
        if (isFound) Console.WriteLine($"Код буквы {ch} является наименьшим четным числом ({min})");
        else Console.WriteLine("Соответствующий элемент не найден");
    }
    static void getThreeTask()
    {
        Console.Write("Введите строку: ");
        string stroka = Console.ReadLine();
        int maxSimb = stroka.Length;
        int podschetZap = 0;
        for (int i = 0; i < maxSimb; i++)
        {
            if (stroka[i] == ',')
            {
                podschetZap = podschetZap + 1;
            }
        }
        stroka = solutionForThree(ref stroka);
        Console.WriteLine("Количество удалённых символов: " + podschetZap);
    }

    static string solutionForThree(ref string stroka)
    {
        stroka = stroka.Replace(",", "");
        Console.WriteLine("Итоговая строка: " + stroka);
        return stroka;
    }
    static void getFourTask()
    {
        Console.Write("Введите строку: ");
        string stroka = Console.ReadLine();
        stroka = solutionForFour(ref stroka);
        Console.Write("Итоговая строка: " + stroka);
    }
    static string solutionForFour(ref string stroka)
    {
        char[] probel = { ' ' };
        stroka = stroka.TrimStart(probel);
        stroka = stroka.TrimEnd(probel);
        stroka = stroka.Replace(" ", "*");
        return stroka;
    }
    static void getFiveTask()
    {
        Console.Write("Введите пароль: ");
        string password = Console.ReadLine();
        if (password.Length >= 6)
        { 
            if (!(password.All(ch => char.IsNumber(ch) || char.IsUpper(ch)) || password.All(ch => char.IsNumber(ch) || char.IsLower(ch))))
            {
                if (!(password.All(ch => char.IsNumber(ch)) || password.All(ch => char.IsLetter(ch))))
                {
                    int simb = 0;
                    int upperCount = 0;
                    for (int i = 0; i < password.Length; i++)
                    {
                        if ((password[i] == '@') || (password[i] == '!') || (password[i] == '#') || (password[i] == '$') || (password[i] == '%') || (password[i] == '^'))
                        {
                            simb = simb + 1;
                        }

                        if (char.IsUpper(password[i]))
                            upperCount = upperCount + 1;
                    }
                    if (simb >= 1 && upperCount >= 1)
                    {
                        char predposledSimb = password[password.Length - 2];
                        if (char.IsNumber(predposledSimb))
                        {
                            Console.Write("Предпоследний символ не должен быть цифрой!");
                        }
                        else
                        {
                            Console.Write("Пароль надёжный!");
                        }
                    }
                    else
                    {
                        Console.WriteLine("Пароль не имеет спец. символов (@, !, #, $, %, ^) или прописных букв!");
                    }
                }
                else
                {
                    Console.Write("Пароль не имеет цифры");
                }
            }
            else
            {
                Console.Write("Пароль содержит запрещённые символы!");
            }
        }
        else
        {
            Console.WriteLine("Пароль имеет длину менее 6 символов");
        }
    }
}